function respondWithError(responseData, options) {
    return {
        status: "error",
        code: options?.code ?? 500,
        result: responseData,
        type: options?.type ?? "error",
        ...options
    };
}
function isErrorResponse(response) {
    return response !== null && "status" in response && response.status === "error";
}
function isSuccessResponse(response) {
    return !isErrorResponse(response);
}
export { respondWithError, isErrorResponse, isSuccessResponse };
//# sourceMappingURL=error.js.map